;;
;;  EELLL---ELisp implemented CATTT
;;
;;  $Id: eelll-mule2.el,v 1.9901 1994/11/20 06:30:49 kaoru Exp kaoru $
;;
;;  Copyright (C) 1991, 1994  Kaoru Maeda (maeda@src.ricoh.co.jp)
;;

;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License version 1
;;  as published by the Free Software Foundation.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;;

(provide 'eelll-mule2)
(require 'tc-mule2)
(tcode-init)

;;
;;  Version
;;
(defun eelll-version ()
  "EELLL $B$N%P!<%8%g%s$rI=<($9$k!#(B"
  (interactive)
  (if (interactive-p)
      (message "EELLL version %s" (eelll-version))
    (substring "$Revision: 1.9901 $" 11 -2)))

;;
;;  Variable
;;

(defvar eelll-text "/usr/local/mule/etc/EELLLTXT"
  "*EELLL$B$NN}=,%F%-%9%H%U%!%$%k(B")

(defvar eelll-move-cursor nil
  "*non-nil$B$K$9$k$H%-!<F~NO$N$?$S$K%+!<%=%k$r?J$a$k(B")

(defvar eelll-text-buffer " *eelll-text*"
  "EELLL$B$NN}=,%F%-%9%H$rF~$l$F$*$/%P%C%U%!(B")

(defvar eelll-window-configuration nil)

(defvar eelll-total-time 0)
(defvar eelll-total-stroke 0)
(defvar eelll-total-error 0)

(defvar eelll-lesson-no nil)
(defvar eelll-first-hand nil)
(defvar eelll-second-hand nil)
(defvar eelll-upper-row nil)
(defvar eelll-lesson-chars nil)
(defvar eelll-text-line nil)
(defvar eelll-text-stroke nil)
(defvar eelll-unmap-table nil)

(defvar eelll-start-time nil)
(defvar eelll-strokes 0)
(defvar eelll-error-strokes 0)


;;
;;  Text
;;

(defun eelll-prepare-text (num)
  "$BN}=,%F%-%9%H(BNUM$B$rMQ0U$9$k!#(BNUM$B$,(Bnil$B$J$i$P<!$N%l%C%9%s$rMQ0U$9$k!#(B"
  (save-excursion
    (set-buffer (get-buffer-create eelll-text-buffer))
    (widen)
    (if (zerop (buffer-size))
	(progn
	  (insert-file-contents eelll-text)
	  (setq buffer-read-only t)
	  (set-buffer-modified-p nil)))
    (if num (goto-char (point-min)))
    (or (re-search-forward (concat "\f\nLesson \\("
				   (if num (int-to-string num) "[0-9]+")
				   "\\):")
			   nil t)
	(error "$BN}=,%F%-%9%H(B%s$B$O$"$j$^$;$s(B" (if num (int-to-string num) "")))
    (setq eelll-lesson-no (string-to-int (buffer-substring (match-beginning 1) (match-end 1))))
    (setq eelll-first-hand (looking-at "[Rr]"))
    (setq eelll-second-hand (looking-at ".[Rr]"))
    (setq eelll-upper-row (looking-at "..!"))
    (forward-line 1)
    (if (looking-at "^Lesson-chars: ")
	(let ((eol (save-excursion (end-of-line 1) (point))))
	  (skip-chars-forward "^ " eol)
	  (setq eelll-lesson-chars (buffer-substring (1+ (point)) eol))
	  (forward-line 1)))
    (let ((p (point)))
      (forward-page 1)
      (narrow-to-region p (1- (point)))
      (goto-char p)))
  eelll-lesson-no)

(defun eelll-compile-text ()
  "$BN}=,%F%-%9%H$N(BLesson-chars: $B9T$r:n$k(B"
  (interactive)
  (find-file eelll-text)
  (widen)
  (goto-char (point-min))
  (while (not (eobp))
    (narrow-to-page 1)
    (goto-char (point-min))
    (skip-chars-forward "^0-9")
    (message (buffer-substring (point) (save-excursion (end-of-line 1) (point))))
    (skip-chars-forward "^:" (save-excursion (end-of-line 1) (point)))
    (setq eelll-first-hand (looking-at ":[Rr]"))
    (setq eelll-second-hand (looking-at ":.[Rr]"))
    (forward-line 1)
    (if (not (looking-at "^Lesson-chars: "))
	(let ((where (point))
	      (chars nil)
	      (upper nil)
	      c last)
	  (while (not (eobp))
	    (skip-chars-forward " \t\n\f" (point-max))
	    (while (not (eolp))
	      (setq chars (cons (buffer-substring (point) (progn (forward-char 1) (point)))
				chars))))
	  (setq chars (sort chars 'string<))
	  (goto-char where)
	  (if chars (insert "Lesson-chars: "))
	  (while chars
	    (catch 'next
	      (setq c (car chars) chars (cdr chars))
	      (if (string= c last) (throw 'next nil))
	      (setq last c)
	      (setq c (eelll-stroke-for-char c))
	      (if (and c
		       (eq eelll-first-hand (tcode-key-address-right-p (car c)))
		       (eq eelll-second-hand (tcode-key-address-right-p (cdr c))))
		  (progn
		    (if (or (< (car c) 10) (< (cdr c) 10)) (setq upper t))
		    (insert last)))))
	  (insert "\n")
	  (if upper
	      (progn
		(goto-char (point-min))
		(end-of-line 1)
		(or (= (preceding-char) ?!)
		    (insert "!"))))
	  (sit-for 0)
	  (if (input-pending-p) (ding))))))

(defun eelll-lesson-line ()
  "$BN}=,%F%-%9%H$N<!$N9T$r$H$C$F$/$k!#=*$o$j$J$i(Bnil$B$rJV$9!#(B
eelll-text-line:	$B0u;z%$%a!<%8(B
eelll-text-stroke:	$B%9%H%m!<%/%$%a!<%8(B"
  (save-excursion
    (set-buffer eelll-text-buffer)
    (skip-chars-forward " \t\n\f" (point-max))
    (and (not (eobp))
	 (let ((p (point)))
	   (forward-line 1)
	   (setq eelll-text-line (buffer-substring p (1- (point))))
	   (setq eelll-text-stroke (eelll-stroke eelll-text-line))
	   eelll-text-line))))

(defun eelll-stroke (str)
  "STR$B$rF~NO$9$k$?$a$N%9%H%m!<%/Ns$rJV$9(B"
  (mapconcat
   (function
    (lambda (ch)
      (let ((c (eelll-stroke-for-char (char-to-string ch))))
	(and c
	     (list (aref eelll-unmap-table (car c))
		   (aref eelll-unmap-table (cdr c)))))))
   (string-to-char-list str) nil))

(defvar eelll-stroke-for-char-hash (make-vector 127 nil))

(defun eelll-stroke-for-char (ch)
  "CH($BA43Q0lJ8;z(B)$B$NBG$AJ}$rJV$9!#(BT-Code$B$GF~NO$G$-$J$1$l$P(Bnil$B$rJV$9!#(B"
  (tcode-bushu-init 3)
  (tcode-stroke-for-char ch))

(defvar eelll-unmap-table nil)
(or eelll-unmap-table
    (progn
      (setq eelll-unmap-table (make-string 40 ?@))
      (let ((i 0)
	    (max (length tcode-keymap-table))
	    k)
	(while (< i max)
	  (if (<= 0 (setq k (aref tcode-keymap-table i)))
	      (aset eelll-unmap-table k (+ i 32)))
	  (setq i (1+ i))))))

;;
;;  Stroke chart
;;
(defun eelll-draw-chart ()
  "$BN}=,%F%-%9%H$NN}=,BP>]$H$J$kJ8;z$N%9%H%m!<%/I=$r:n$k(B"
  (save-excursion
    (set-buffer (get-buffer-create " *EELLL-Help*"))
    (widen)
    (erase-buffer)
    (goto-char (point-min))
    (let ((i 0)
	  j k
	  (c (if eelll-second-hand 1 4)))
      (while (< i 4)
	(setq i (1+ i) j 0)
	(while (< j 4)
	  (insert "    ")
	  (setq j (1+ j) k 0)
	  (while (< k 5)
	    (setq k (1+ k))
	    (insert "$B!>!>!>!>!>(B  ")
	    (if (= k c) (insert "  ")))
	  (delete-horizontal-space)
	  (insert "\n"))
	(if (< i 4) (insert "\n"))))
    (let (fr fc sr sc)
      (mapcar
       (function
	(lambda (c)
	  (setq fr (eelll-stroke-for-char (char-to-string c))
		sr (cdr fr)
		fc (% (car fr) 5)
		fr (/ (car fr) 10)
		sc (% sr 5)
		sr (/ sr 10))
	  (goto-line (+ (* sr 5) fr 1))
	  (move-to-column (+ 4 (* 12 sc) (* 2 fc)
			  (if (> sc (if eelll-second-hand 0 3)) 2 0)))
	  (delete-char 1)
	  (insert c)))
       (string-to-char-list eelll-lesson-chars)))
    (goto-char (point-min))
    (forward-line 1)
    (delete-region (point-min) (point))
    (if eelll-upper-row
	()
      (forward-line 5) (delete-region (point-min) (point))
      (forward-line 4) (delete-region (point) (save-excursion (forward-line 1) (point)))
      (forward-line 4) (delete-region (point) (save-excursion (forward-line 1) (point))))
    (goto-char (point-min))
    (let ((num (int-to-string eelll-lesson-no)))
      (delete-char (length num))
      (insert num))
    (forward-line 1)
    (delete-char 2)
    (insert (if eelll-first-hand "R" "L")
	    (if eelll-second-hand "R" "L"))
    (set-buffer-modified-p nil)))

;;
;;  String Matching
;;
(defun eelll-match (template string quest)
  "TEMPLATE$B$r$*<jK\$H$7$FF~NO$5$l$?J8;zNs(BSTRING$B$N:NE@$r$9$k!#85$NJ8$O(BQUEST$B!#(B
$BFsMWAG$N%j%9%H(B(RESULT ERROR)$B$rJV$9!#(B"
  (let ((link (list  '(0 . 0)))
	(len-1 (1- (length string)))
	(max (length template))
	(j 0) i)
    (while (< j max)
      (setq i 0)
      (while (< i len-1)
	(and (= (aref template j) (aref string i))
	     (= (aref template (1+ j)) (aref string (1+ i)))
	     (let ((l link) (p nil) (i+2 (+ i 2)) (j+2 (+ j 2)) dif)
	       (while l
		 (if (and (>= i (car (car l)))
			  (>= j (cdr (car l))))
		     (setq l nil)
		   (setq p (car l) l (cdr l))))
	       (if p
		   (if (or (> (setq dif (- (+ (car p) (cdr p)) i+2 j+2)) 0)
			   (and (= dif 0) (< i+2 (car p))))
		       (progn (setcar p i+2)
			      (setcdr p j+2)))
		 (setq link (cons (cons i+2 j+2) link)))))
	(setq i (1+ i)))
      (setq j (+ j 2)))
    (let ((res (vconcat (string-to-char-list string)))
	  (quest-v (vconcat (string-to-char-list quest)))
	  (pi (length string))
	  (pj max)
	  (err 0)
	  (l link))
      (while (> (setq i (car (car l))) 0)
	(setq j (cdr (car l))
	      l (cdr l)
	      err (+ err (max (- pi i) (- pj j)) -2))
	(aset res (- i 2) nil)
	(aset res (- i 1) (aref quest-v (- (/ j 2) 1)))
	(setq pi i pj j))
      (setq err (+ err (max pi pj)))
      (setq res
	    (mapconcat (function
			(lambda (ch)
			  (and ch (char-to-string ch))))
		       res nil))
      (list res err))))

;;
;;  Mode setup
;;

(defvar eelll-mode-map nil
  "EELLL $B%b!<%I$G;H$&%-!<%^%C%W(B")
(if eelll-mode-map
    ()
  (setq eelll-mode-map (make-keymap))
  (substitute-key-definition nil 'eelll-undefined eelll-mode-map)
  (define-key eelll-mode-map "\177" 'eelll-delete-char)
  (define-key eelll-mode-map "\e" 'ESC-prefix)
  (define-key eelll-mode-map "\C-c" 'mode-specific-command-prefix)
  (define-key eelll-mode-map "\C-j" 'eelll-return)
  (define-key eelll-mode-map "\C-m" 'eelll-return)
  (define-key eelll-mode-map "\C-g" 'keyboard-quit)
  (define-key eelll-mode-map "\C-u" 'universal-argument)
  (define-key eelll-mode-map "\C-x" 'Control-X-prefix)
  (define-key eelll-mode-map "\C-]" 'abort-recursive-edit)
  (define-key eelll-mode-map "?" 'eelll-help)
  (mapconcat (function
	      (lambda (key)
		(define-key eelll-mode-map (char-to-string key) 'eelll-key)
		nil))
	     eelll-unmap-table nil))

(defun eelll-mode ()
  "EELLL $B$O(B Emacs Lisp $B$G<B8=$5$l$?(B T-Code $BN}=,%W%m%0%i%`$G$9!#(B
$B2hLL$KI=<($5$l$?J8;zNs$r$=$N$^$^F~NO$7$F$/$@$5$$!#(B
$B0l9T$NF~NO$,=*$o$C$?$i%j%?!<%s%-!<$rBG$C$F$/$@$5$$!#(B

$B2hLL$N>eH>J,$K$O:#$N%l%C%9%s$G=,$&J8;z$N%9%H%m!<%/I=$,I=<($5$l$F$$$^$9!#(B

EELLL $BFb$G$O$[$H$s$I$N%3%^%s%I$,6X;_$5$l$F$$$^$9!#(B
$B$^$:(B \\[switch-to-buffer] $B$GB>$N%P%C%U%!$K0\$C$F$+$i(B
$B%3%^%s%I$r<B9T$7$F$/$@$5$$!#(B"
  (use-local-map eelll-mode-map)
  (setq major-mode 'eelll-mode)
  (setq mode-name "EELLL")
  (setq mode-line-buffer-identification '("EELLL: %17b"))
  (run-hooks 'eelll-mode-hook))

(defun eelll-undefined ()
  (interactive)
  (message (substitute-command-keys "\\[switch-to-buffer] SOME-BUFFER first.")))

(defun eelll-delete-char ()
  (interactive)
  (message "$B4V0c$$$r5$$K$;$:$I$s$I$sF~NO$7$F$/$@$5$$(B"))

;;
;;  Main Driver
;;

(defun eelll (lesson)
  "EELLL $B$r;O$a$k!#>\$7$/$O(B eelll-mode $B$N2r@b$r8+$h!#(B"
  (interactive "nEELLL $B%l%C%9%sHV9f(B: ")
  (eelll-prepare-text lesson)
  (eelll-setup-lesson))

(defun eelll-setup-lesson ()
  (eelll-draw-chart)
  (switch-to-buffer "*EELLL*")
  (eelll-mode)
  (widen) (erase-buffer)
  (delete-other-windows)
  (split-window-vertically
   (save-excursion
     (set-buffer " *EELLL-Help*")
     (1+ (count-lines (point-min) (point-max)))))
  (switch-to-buffer " *EELLL-Help*")
  (goto-char (point-min))
  (other-window 1)
  (setq eelll-window-configuration (current-window-configuration))
  (setq eelll-start-time nil
	eelll-error-strokes 0
	eelll-strokes 0)
  (save-excursion
    (set-buffer eelll-text-buffer)
    (goto-char (point-min)))
  (insert "$B%j%?!<%s%-!<$rBG$F$P;O$^$j$^$9(B: "))

(defun eelll-key ()
  (interactive)
  (save-excursion
    (set-buffer " *eelll-strokes*")
    (insert (char-to-string last-command-char)))
  (if eelll-move-cursor
      (insert " ")))

(defun eelll-return ()
  (interactive)
  (if eelll-start-time
      (progn
	(delete-region (point) (progn (beginning-of-line 1) (point)))
	(let* ((str (save-excursion
		      (set-buffer " *eelll-strokes*")
		      (buffer-string)))
	       (res (eelll-match eelll-text-stroke str eelll-text-line))
	       (err (car (cdr res))))
	  (insert (car res))
	  (setq eelll-strokes (+ eelll-strokes (length str))
		eelll-error-strokes (+ eelll-error-strokes err))))
    (setq eelll-start-time (eelll-current-time)))
  (if (null (eelll-lesson-line))
      (eelll-end-lesson)
    (save-excursion
      (set-buffer (get-buffer-create " *eelll-strokes*"))
      (widen) (erase-buffer))
    (insert "\n\n" eelll-text-line "\n")
    (set-window-configuration eelll-window-configuration)
    (goto-char (point-max))
    (set-window-start
     (selected-window)
     (save-excursion (forward-line (- 2 (window-height))) (point)))))

(defun eelll-current-time ()
  (let ((str (current-time-string)))
    (string-match "\\([0-9][0-9]\\):\\([0-9][0-9]\\):\\([0-9][0-9]\\)" str)
    (+ (* 3600 (string-to-int (substring str (match-beginning 1) (match-end 1))))
       (* 60 (string-to-int (substring str (match-beginning 2) (match-end 2))))
       (string-to-int (substring str (match-beginning 3) (match-end 3))))))

(defun eelll-percentage (num den)
  (let ((res%  (min 9999 (/ num (max 1 den)))))
    (format "%d.%d" (/ res% 10) (% res% 10))))

(defun eelll-display-score (time stroke err)
  (let ((cnt (- stroke err)))
    (set-buffer "*EELLL*")
    (insert "\n\n($BAmBG80@.@S(B)$BKhBG80(B "
	    (eelll-percentage (* 10000 time) stroke) " $B%_%jIC(B, "
	    "$BKhJ,(B " (eelll-percentage (* 600 stroke) time) " $BBG80(B.\n")
    (if (> cnt 0)
	(insert "($B<BBG80@.@S(B)$BKhBG80(B "
	    (eelll-percentage (* 10000 time) cnt) " $B%_%jIC(B, "
	    "$BKhJ,(B " (eelll-percentage (* 600 cnt) time) " $BBG80(B.\n"))
    (if (> eelll-strokes 0)
	(insert "              $B%(%i!<%l!<%H(B "
		(eelll-percentage (* 1000 err) stroke)
		"%.\n"))))

(defun eelll-end-lesson ()
  (let ((time (% (- (eelll-current-time) eelll-start-time -86399) 86400)))
    (setq eelll-total-time (+ eelll-total-time time)
	  eelll-total-stroke (+ eelll-total-stroke eelll-strokes)
	  eelll-total-error (+ eelll-total-error eelll-error-strokes))
    (eelll-display-score time eelll-strokes eelll-error-strokes)
    (delete-other-windows)
    (set-window-start
     (selected-window)
     (save-excursion
       (forward-line (- 1 (window-height))) (point)))
    (if (y-or-n-p "$B$b$&0lEY%H%i%$$7$^$9$+(B: ")
	(eelll-setup-lesson)
      (if (y-or-n-p "$B<!$N%l%C%9%s$K?J$_$^$9$+(B: ")
	  (progn (eelll-prepare-text nil)
		 (eelll-setup-lesson))
	(eelll-end))))
  (message ""))

(defun eelll-end ()
  (set-buffer "*EELLL*")
  (widen)
  (erase-buffer)
  (insert "$BAm9g@.@S(B\n\n")
  (eelll-display-score eelll-total-time eelll-total-stroke eelll-total-error)
  (insert "\n    $BF~NOBG80?t(B " (int-to-string eelll-total-stroke) " $BBG80(B. ")
  (insert "$B=jMW;~4V(B " (int-to-string eelll-total-time) " $BIC(B.\n")
  (message "$B$*$D$+$l$5$^$G$7$?!#$I$l$+%-!<$r$*$7$F$/$@$5$$(B")
  (read-char)
  (bury-buffer "*EELLL*")
  (switch-to-buffer (other-buffer "*EELLL*"))
  (message ""))
